//------------------------------------------------------------------------------
// CERN BE-CO-HT
// White Rabbit Trigger Distribution (WRTD)
// https://ohwr.org/projects/wrtd
//------------------------------------------------------------------------------
//
// unit name:   WrtdAlarm, WrtdAlarmCollection
//
// description: A SystemVerilog Class for a WRTD "alarm" repeated capability
//
//------------------------------------------------------------------------------
// Copyright CERN 2019
//------------------------------------------------------------------------------
// Copyright and related rights are licensed under the Solderpad Hardware
// License, Version 2.0 (the "License"); you may not use this file except
// in compliance with the License. You may obtain a copy of the License at
// http://solderpad.org/licenses/SHL-2.0.
// Unless required by applicable law or agreed to in writing, software,
// hardware and materials distributed under this License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing permissions
// and limitations under the License.
//------------------------------------------------------------------------------

`ifndef __WRTD_ALARM_INCLUDED
 `define __WRTD_ALARM_INCLUDED

 `include "wrtd_rep_cap.svh"

class WrtdAlarm extends WrtdRepCap;

   function new ( int core, int index, string name = "" );
      super.new ( core, index, name );
      clear();
   endfunction // new

   function void clear ( );
      super.clear();
   endfunction // clear

   function repcap_data data_pack ( );
   endfunction // data_pack

   function void data_unpack ( repcap_data data );
   endfunction // data_unpack

endclass //WrtdAlarm

class WrtdAlarmCollection extends WrtdRepCapCollection;
   protected WrtdAlarm collection[];

   function new ( int size, string name );
      super.new ( size, name );
   endfunction // new

endclass // WrtdAlarmCollection

`endif //  `ifndef __WRTD_ALARM_INCLUDED
